//NEEDS: on over update the status bar with the projected URL.
//this requires both nav(1) & nav(-1) functions to be fired off and store the resultant URLS
//appened to each tab
//then the buttons just fire off a new function that uses the URLs and resets the location

// Define a prompts object that inherits the method for the alert prompt
var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);                        
                        
//Define a prefs object that inherits the methods for getting browser add on preferences
var PrefService	= Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

//pref for how to handle ( 09-10 vs 9-10 ) digits
var digit	= true;
//regex to find a digit in a string
var regvar = /\d+/;
var myregexp = new RegExp(regvar);

//Instead of watching a page load an initMiner - we need to watch for the URL text in the nav bar to change.
//window.addEventListener('DOMContentLoaded', initMiner, false);
window.addEventListener("load", init, true);
window.addEventListener("focus", init, true); 


function digitToggle(){
		PrefService.setBoolPref('jumperpackage.jumper.digit', !PrefService.getBoolPref('jumperpackage.jumper.digit') );
		prefInit();
		return true;
}


function prefInit(){ //Preferences init....**probally best to use an "observer" here instead**
	var label = "01";
	digit	= PrefService.getBoolPref('jumperpackage.jumper.digit');
	if (!digit){
		label = "1";
	}
	document.getElementById('fj-switch').textContent = label;
	
	//Show-Hide Fire Jumper interface elements
	var buttons = PrefService.getBoolPref('jumperpackage.jumper.buttons');
	document.getElementById('fj-menu').hidden = !buttons;
	var statusPref = PrefService.getBoolPref('jumperpackage.jumper.statusPref');
	document.getElementById('fj-digit').hidden = !statusPref;
	return true;
}


function init(){
	prefInit();	
	//probally need to check to make sure the event that fired this is a top level content and not a frame or xmlhttp first
	if ( gBrowser ){
		var current_doc = gBrowser.selectedBrowser.contentDocument;	
		var currentHREF = current_doc.location.href;
		var dec = document.getElementById('dec');
		var inc = document.getElementById('inc');
		if ( checkURL(currentHREF) ) {		
			if (document.getElementById('miner-buttonInc_Disabled')) {
				dec.disabled = false;
				inc.disabled = false;
				document.getElementById('miner-buttonInc_Disabled').id = 'miner-buttonInc';
				document.getElementById('miner-buttonDec_Disabled').id = 'miner-buttonDec';
			}
		} else {
			if (document.getElementById('miner-buttonInc')){
				dec.disabled = true;
				inc.disabled = true;
				document.getElementById('miner-buttonInc').id = 'miner-buttonInc_Disabled';
				document.getElementById('miner-buttonDec').id = 'miner-buttonDec_Disabled';
			}
		}
	}
}

//given an element as el return an array [0,0] of the selected txt start and end.
function getSelection( el ){
	if ( el.selectionStart == undefined ){
		var r = document.selection.createRange();
		return new Array( r.start, r.end );
	} else {
		return new Array( el.selectionStart, el.selectionEnd );
	}
}

function nav(direction){
	if (document.getElementById('dec').disabled == false ){

		var loc = direction;

		// get the current URL of the selected tab
		var current_doc = gBrowser.selectedBrowser.contentDocument;	
		var currentHREF = current_doc.location.href;

		//Use text selection from the URL Location Bar to Increment
		var selectedText = getSelection(gURLBar);

		if (selectedText[0] == selectedText[1]){ //no URL fragment has been selected
			if ( gBrowser.selectedBrowser.selectedText != null ){ //use the last selected text range if it exists.
				selectedText = gBrowser.selectedBrowser.selectedText; 
			} else { //otherwise default to selected text the entire string.
				selectedText[0] = 0;
				selectedText[1] = currentHREF.length;	
			}
		} else { //save the selected text's range to a variable on the selected tab object
			gBrowser.selectedBrowser.selectedText = selectedText;
		}

		//set the section of the string to increment
		var incrementText = currentHREF.substring(selectedText[0],selectedText[1]); 
		var new_loc = Increment(incrementText, loc);	

		//format back into a valid url by attaching the front and back of the url to the new location.
		var new_URL = currentHREF.substring(0, selectedText[0]) + new_loc + currentHREF.substring(selectedText[1], currentHREF.length);
		if ( new_URL != null ){
			current_doc.location = new_URL;
			return true;
		}
	}
	return false;
}

function checkURL(URL){
	var strHTML = URL;
	return myregexp.test(strHTML);
}

function Increment(targetStr,argloc){
	var loc = parseInt(argloc);
	var str = targetStr;
	var result = myregexp.exec(str);
	var preDigit = getLeadingZeros(result,loc);
	if ( result != null ){
		result = str.replace(myregexp, preDigit+(parseInt(result,10)+loc)); //parseInt(string, base) 10 for normal numbers
	}
	return result;
}

//This Function accepts a number string and an increment number then returns a string a zeros to add.
function getLeadingZeros(argnum,argloc){
	var result = "";
	var loc = parseInt(argloc);
	if ( ( loc < 0 ) && ( digit == false ) ) { //decrementing mode && strip all leading all 0's
		return result;
	}
	var num = argnum;
	var numFrom = num + "";
	var numTo = (parseInt(num,10) + loc) + "";
	var diff = numFrom.length - numTo.length; //diff is the number of zero's to prepend in the result string.
		if ( diff > 0 ){
			for ( var i = 0; i < diff; i++ ) {
				result += "0";
			}
		}

	return result;
}
